<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: eval_ehrhart.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>eval_ehrhart.c</h1><a href="eval__ehrhart_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of PolyLib.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    PolyLib is free software: you can redistribute it and/or modify</span>
<a name="l00005"></a>00005 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00006"></a>00006 <span class="comment">    the Free Software Foundation, either version 3 of the License, or</span>
<a name="l00007"></a>00007 <span class="comment">    (at your option) any later version.</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    PolyLib is distributed in the hope that it will be useful,</span>
<a name="l00010"></a>00010 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00011"></a>00011 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00012"></a>00012 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00015"></a>00015 <span class="comment">    along with PolyLib.  If not, see &lt;http://www.gnu.org/licenses/&gt;.</span>
<a name="l00016"></a>00016 <span class="comment">*/</span>
<a name="l00017"></a>00017 
<a name="l00018"></a>00018 <span class="comment">/************************************************/</span>
<a name="l00019"></a>00019 <span class="comment">/*  eval_ehrhart.c                              */</span>
<a name="l00020"></a>00020 <span class="comment">/* functions to evaluate an Ehrhart polynomial. */</span>
<a name="l00021"></a>00021 <span class="comment">/* written by Emmanuel Jeannot (c) 1997.        */</span>
<a name="l00022"></a>00022 <span class="comment">/*  Emmanuel.Jeannot@ens-lyon.fr                */</span>
<a name="l00023"></a>00023 <span class="comment">/*  http://www.ens-lyon.fr/~ejeannot            */</span>
<a name="l00024"></a>00024 <span class="comment">/*                                              */</span>
<a name="l00025"></a>00025 <span class="comment">/* modified 1998, 2000, Vincent Loechner        */</span>
<a name="l00026"></a>00026 <span class="comment">/* (ArithmetiqueLib, Param_Names)               */</span>
<a name="l00027"></a>00027 <span class="comment">/************************************************/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;math.h&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;<a class="code" href="assert_8h.html">assert.h</a>&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;<a class="code" href="polylib_8h.html">polylib/polylib.h</a>&gt;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">/* #define EVAL_EHRHART_DEBUG  */</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">/********************************************************/</span>
<a name="l00039"></a>00039 <span class="comment">/* function in domain                                   */</span>
<a name="l00040"></a>00040 <span class="comment">/*    check if the parameters in list_args              */</span>
<a name="l00041"></a>00041 <span class="comment">/*    verifies the constraints of Domain P              */</span>
<a name="l00042"></a>00042 <span class="comment">/********************************************************/</span>
<a name="l00043"></a><a class="code" href="eval__ehrhart_8h.html#aeaa7a17d905454d792bc8bb5409f941d">00043</a> <span class="keywordtype">int</span> <a class="code" href="eval__ehrhart_8c.html#aeaa7a17d905454d792bc8bb5409f941d">in_domain</a>(<a class="code" href="structpolyhedron.html">Polyhedron</a> *P, Value *list_args) {
<a name="l00044"></a>00044   
<a name="l00045"></a>00045   <span class="keywordtype">int</span> col,row;
<a name="l00046"></a>00046   Value v; <span class="comment">/* value of the constraint of a row when</span>
<a name="l00047"></a>00047 <span class="comment">               parameters are instanciated*/</span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="keywordflow">if</span>( !P )
<a name="l00050"></a>00050           <span class="keywordflow">return</span>( 0 );
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <a class="code" href="polyhedron_8h.html#a54a764faf683e794f4db092c8d050104">POL_ENSURE_INEQUALITIES</a>(P);
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(v); 
<a name="l00055"></a>00055   
<a name="l00056"></a>00056   <span class="comment">/* P-&gt;Constraint constraint matrice of polyhedron P */</span>  
<a name="l00057"></a>00057   <span class="keywordflow">for</span>(row=0;row&lt;P-&gt;<a class="code" href="structpolyhedron.html#a2db05293e731089b9198d45cf027bd1c">NbConstraints</a>;row++) {
<a name="l00058"></a>00058     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(v,P-&gt;<a class="code" href="structpolyhedron.html#ab2691b8eb5d2dc43a509ac2094d2bc73">Constraint</a>[row][P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>+1]); <span class="comment">/*constant part*/</span>
<a name="l00059"></a>00059     <span class="keywordflow">for</span>(col=1;col&lt;P-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>+1;col++) {
<a name="l00060"></a>00060       <a class="code" href="source_2arith_2arithmetique_8h.html#a9900fbd029b36f5887e587642a064a52">value_addmul</a>(v, P-&gt;<a class="code" href="structpolyhedron.html#ab2691b8eb5d2dc43a509ac2094d2bc73">Constraint</a>[row][col], list_args[col-1]); 
<a name="l00061"></a>00061     }  
<a name="l00062"></a>00062     <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a47d32925340d2dc99ef2d4215080a60d">value_notzero_p</a>(P-&gt;<a class="code" href="structpolyhedron.html#ab2691b8eb5d2dc43a509ac2094d2bc73">Constraint</a>[row][0])) {
<a name="l00063"></a>00063         
<a name="l00064"></a>00064       <span class="comment">/*if v is not &gt;=0 then this constraint is not respected */</span>
<a name="l00065"></a>00065       <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#af031da52c8a160fd1ee6e4c793f8c78a">value_neg_p</a>(v)) {
<a name="l00066"></a>00066         <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(v);
<a name="l00067"></a>00067         <span class="keywordflow">return</span>( <a class="code" href="eval__ehrhart_8c.html#aeaa7a17d905454d792bc8bb5409f941d">in_domain</a>(P-&gt;<a class="code" href="structpolyhedron.html#aab97126cb9e56431d40eaf4e68b3953d">next</a>, list_args) );
<a name="l00068"></a>00068       }        
<a name="l00069"></a>00069     }
<a name="l00070"></a>00070     <span class="keywordflow">else</span> {
<a name="l00071"></a>00071       
<a name="l00072"></a>00072       <span class="comment">/*if v is not = 0 then this constraint is not respected */</span>
<a name="l00073"></a>00073       <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a47d32925340d2dc99ef2d4215080a60d">value_notzero_p</a>(v)) {
<a name="l00074"></a>00074         <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(v);
<a name="l00075"></a>00075         <span class="keywordflow">return</span>( <a class="code" href="eval__ehrhart_8c.html#aeaa7a17d905454d792bc8bb5409f941d">in_domain</a>(P-&gt;<a class="code" href="structpolyhedron.html#aab97126cb9e56431d40eaf4e68b3953d">next</a>, list_args) );
<a name="l00076"></a>00076       }
<a name="l00077"></a>00077     }
<a name="l00078"></a>00078   }
<a name="l00079"></a>00079   
<a name="l00080"></a>00080   <span class="comment">/* if not return before this point =&gt; all the constraints are respected */</span>
<a name="l00081"></a>00081   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(v);
<a name="l00082"></a>00082   <span class="keywordflow">return</span> 1;
<a name="l00083"></a>00083 } <span class="comment">/* in_domain */</span>
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 <span class="comment">/****************************************************/</span>
<a name="l00086"></a>00086 <span class="comment">/* function compute enode                           */</span>
<a name="l00087"></a>00087 <span class="comment">/*     compute the value of enode p with parameters */</span>
<a name="l00088"></a>00088 <span class="comment">/*     list &quot;list_args                              */</span>
<a name="l00089"></a>00089 <span class="comment">/*     compute the polynomial or the periodic       */</span>
<a name="l00090"></a>00090 <span class="comment">/****************************************************/</span>
<a name="l00091"></a>00091 
<a name="l00092"></a><a class="code" href="eval__ehrhart_8c.html#af8ffd38faa2d17abcb0ed78b6d3f53b0">00092</a> <span class="keyword">static</span> <span class="keywordtype">double</span> <a class="code" href="eval__ehrhart_8c.html#af8ffd38faa2d17abcb0ed78b6d3f53b0">compute_enode</a>(<a class="code" href="struct__enode.html">enode</a> *<a class="code" href="vector_8c.html#aa45b2e3dcf291527c5aedc420819adfc">p</a>, Value *list_args) {
<a name="l00093"></a>00093   
<a name="l00094"></a>00094   <span class="keywordtype">int</span> i;
<a name="l00095"></a>00095   Value <a class="code" href="polyparam_8c.html#a742204794ea328ba293fe59cec79b990">m</a>, param;
<a name="l00096"></a>00096   <span class="keywordtype">double</span> res=0.0;
<a name="l00097"></a>00097     
<a name="l00098"></a>00098   <span class="keywordflow">if</span> (!p)
<a name="l00099"></a>00099     <span class="keywordflow">return</span>(0.);
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(m);
<a name="l00102"></a>00102   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(param);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keywordflow">if</span> (p-&gt;<a class="code" href="struct__enode.html#a36787a943f0f24530a8934c48a69d282">type</a> == <a class="code" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409fedaa486649798da33c51389df14eaccd3ce">polynomial</a>) {
<a name="l00105"></a>00105     <span class="keywordflow">if</span> (p-&gt;<a class="code" href="struct__enode.html#aba9a89a7893638f2ad9d77c9d0247797">size</a> &gt; 1)
<a name="l00106"></a>00106                  <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(param,list_args[p-&gt;<a class="code" href="struct__enode.html#a1230adfbd7f0ca1f8628a03be4e6ef35">pos</a>-1]);
<a name="l00107"></a>00107     
<a name="l00108"></a>00108     <span class="comment">/* Compute the polynomial using Horner&apos;s rule */</span>
<a name="l00109"></a>00109     <span class="keywordflow">for</span> (i=p-&gt;<a class="code" href="struct__enode.html#aba9a89a7893638f2ad9d77c9d0247797">size</a>-1;i&gt;0;i--) {
<a name="l00110"></a>00110       res +=<a class="code" href="eval__ehrhart_8c.html#a3f1631cacb65ff7aa29df190b4d30d00">compute_evalue</a>(&amp;p-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[i],list_args);
<a name="l00111"></a>00111       res *=VALUE_TO_DOUBLE(param);
<a name="l00112"></a>00112     }
<a name="l00113"></a>00113     res +=<a class="code" href="eval__ehrhart_8c.html#a3f1631cacb65ff7aa29df190b4d30d00">compute_evalue</a>(&amp;p-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[0],list_args);
<a name="l00114"></a>00114   }
<a name="l00115"></a>00115   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (p-&gt;<a class="code" href="struct__enode.html#a36787a943f0f24530a8934c48a69d282">type</a> == <a class="code" href="types_8h.html#a01e5f42033d0f34c1a182a25a7409feda3cb930eb7594d2236ab4fc6dd622c207">periodic</a>) {
<a name="l00116"></a>00116     <a class="code" href="source_2arith_2arithmetique_8h.html#a864613888dc46f15679aa4f63e468f89">value_assign</a>(m,list_args[p-&gt;<a class="code" href="struct__enode.html#a1230adfbd7f0ca1f8628a03be4e6ef35">pos</a>-1]);
<a name="l00117"></a>00117     
<a name="l00118"></a>00118     <span class="comment">/* Choose the right element of the periodic */</span>
<a name="l00119"></a>00119     <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(param,p-&gt;<a class="code" href="struct__enode.html#aba9a89a7893638f2ad9d77c9d0247797">size</a>);
<a name="l00120"></a>00120     <a class="code" href="source_2arith_2arithmetique_8h.html#a60a1720f53f9951170f929062609ddcf">value_pmodulus</a>(m,m,param);
<a name="l00121"></a>00121     res = <a class="code" href="eval__ehrhart_8c.html#a3f1631cacb65ff7aa29df190b4d30d00">compute_evalue</a>(&amp;p-&gt;<a class="code" href="struct__enode.html#a215794f8b8ab87573bd46f14a8e916d4">arr</a>[VALUE_TO_INT(m)],list_args);
<a name="l00122"></a>00122   }
<a name="l00123"></a>00123   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(m);
<a name="l00124"></a>00124   <a class="code" href="source_2arith_2arithmetique_8h.html#ab9b282921e85a0527d462d331533d619">value_clear</a>(param);
<a name="l00125"></a>00125   <span class="keywordflow">return</span> res;
<a name="l00126"></a>00126 } <span class="comment">/* compute_enode */</span>
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="comment">/*************************************************/</span>
<a name="l00129"></a>00129 <span class="comment">/* return the value of Ehrhart Polynomial        */</span>
<a name="l00130"></a>00130 <span class="comment">/* It returns a double, because since it is      */</span>
<a name="l00131"></a>00131 <span class="comment">/* a recursive function, some intermediate value */</span>
<a name="l00132"></a>00132 <span class="comment">/* might not be integral                         */</span>
<a name="l00133"></a>00133 <span class="comment">/*************************************************/</span>
<a name="l00134"></a>00134 
<a name="l00135"></a><a class="code" href="eval__ehrhart_8h.html#a3f1631cacb65ff7aa29df190b4d30d00">00135</a> <span class="keywordtype">double</span> <a class="code" href="eval__ehrhart_8c.html#a3f1631cacb65ff7aa29df190b4d30d00">compute_evalue</a>(<a class="code" href="struct__evalue.html">evalue</a> *e,Value *list_args) {
<a name="l00136"></a>00136   
<a name="l00137"></a>00137   <span class="keywordtype">double</span> res;
<a name="l00138"></a>00138   
<a name="l00139"></a>00139   <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a47d32925340d2dc99ef2d4215080a60d">value_notzero_p</a>(e-&gt;<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>)) {
<a name="l00140"></a>00140     <span class="keywordflow">if</span> (<a class="code" href="source_2arith_2arithmetique_8h.html#a5f258141f9e07b66da01ff7f4fe3d56d">value_notone_p</a>(e-&gt;<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>)) 
<a name="l00141"></a>00141       res = VALUE_TO_DOUBLE(e-&gt;x.n) / VALUE_TO_DOUBLE(e-&gt;<a class="code" href="struct__evalue.html#ae4aada7b06d44dcbf9f4d2daf1834e29">d</a>);
<a name="l00142"></a>00142     <span class="keywordflow">else</span> 
<a name="l00143"></a>00143       res = VALUE_TO_DOUBLE(e-&gt;x.n);
<a name="l00144"></a>00144   }
<a name="l00145"></a>00145   <span class="keywordflow">else</span> 
<a name="l00146"></a>00146     res = <a class="code" href="eval__ehrhart_8c.html#af8ffd38faa2d17abcb0ed78b6d3f53b0">compute_enode</a>(e-&gt;x.p,list_args);
<a name="l00147"></a>00147   <span class="keywordflow">return</span> res;
<a name="l00148"></a>00148 } <span class="comment">/* compute_evalue */</span>
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="comment">/****************************************************/</span>
<a name="l00152"></a>00152 <span class="comment">/* function compute_poly :                          */</span>
<a name="l00153"></a>00153 <span class="comment">/* Check for the good validity domain               */</span>
<a name="l00154"></a>00154 <span class="comment">/* return the number of point in the Polyhedron     */</span>
<a name="l00155"></a>00155 <span class="comment">/* in allocated memory                              */</span>
<a name="l00156"></a>00156 <span class="comment">/* Using the Ehrhart pseudo-polynomial              */</span>
<a name="l00157"></a>00157 <span class="comment">/****************************************************/</span>
<a name="l00158"></a><a class="code" href="eval__ehrhart_8h.html#af970e7f69cbf548188a8f3754001a150">00158</a> Value *<a class="code" href="eval__ehrhart_8c.html#af970e7f69cbf548188a8f3754001a150">compute_poly</a>(<a class="code" href="struct__enumeration.html">Enumeration</a> *en,Value *list_args) {
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   Value *tmp;
<a name="l00161"></a>00161   <span class="comment">/*        double d; int i; */</span>
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   tmp = (Value *) malloc (<span class="keyword">sizeof</span>(Value));
<a name="l00164"></a>00164   <a class="code" href="assert_8h.html#a07d17d6d5d1074c0969bc5d3c3d1d84a">assert</a>(tmp != NULL);
<a name="l00165"></a>00165   <a class="code" href="source_2arith_2arithmetique_8h.html#af71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(*tmp);
<a name="l00166"></a>00166   <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(*tmp,0);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="keywordflow">if</span>(!en)
<a name="l00169"></a>00169     <span class="keywordflow">return</span>(tmp);        <span class="comment">/* no ehrhart polynomial */</span>
<a name="l00170"></a>00170   <span class="keywordflow">if</span>(en-&gt;<a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">ValidityDomain</a>) {
<a name="l00171"></a>00171     <span class="keywordflow">if</span>(!en-&gt;<a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">ValidityDomain</a>-&gt;<a class="code" href="structpolyhedron.html#a2a02cea8b7ba3dde415041b8b2373bc8">Dimension</a>) { <span class="comment">/* no parameters */</span>
<a name="l00172"></a>00172       <a class="code" href="source_2arith_2arithmetique_8h.html#a3a9e8def0399e848b9f715238e2378fa">value_set_double</a>(*tmp,<a class="code" href="eval__ehrhart_8c.html#a3f1631cacb65ff7aa29df190b4d30d00">compute_evalue</a>(&amp;en-&gt;<a class="code" href="struct__enumeration.html#aa499b062a10ce16356e9b52d25cae0d9">EP</a>,list_args)+.25);
<a name="l00173"></a>00173       <span class="keywordflow">return</span>(tmp);
<a name="l00174"></a>00174     }
<a name="l00175"></a>00175   }  
<a name="l00176"></a>00176   <span class="keywordflow">else</span> 
<a name="l00177"></a>00177     <span class="keywordflow">return</span>(tmp);  <span class="comment">/* no Validity Domain */</span>    
<a name="l00178"></a>00178   <span class="keywordflow">while</span>(en) {
<a name="l00179"></a>00179     <span class="keywordflow">if</span>(<a class="code" href="eval__ehrhart_8c.html#aeaa7a17d905454d792bc8bb5409f941d">in_domain</a>(en-&gt;<a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">ValidityDomain</a>,list_args)) {
<a name="l00180"></a>00180       
<a name="l00181"></a>00181 <span class="preprocessor">#ifdef EVAL_EHRHART_DEBUG</span>
<a name="l00182"></a>00182 <span class="preprocessor"></span>      <a class="code" href="polyparam_8c.html#afa315bc856959f9a781359f69b74d7a4">Print_Domain</a>(stdout,en-&gt;<a class="code" href="struct__enumeration.html#a57e35419d63ab12898542ef58d8decac">ValidityDomain</a>,NULL);
<a name="l00183"></a>00183       <a class="code" href="ehrhart_8c.html#a99718adf05e065181f35f5ca847f94b0">print_evalue</a>(stdout,&amp;en-&gt;<a class="code" href="struct__enumeration.html#aa499b062a10ce16356e9b52d25cae0d9">EP</a>,NULL);
<a name="l00184"></a>00184 <span class="preprocessor">#endif</span>
<a name="l00185"></a>00185 <span class="preprocessor"></span>      
<a name="l00186"></a>00186       <span class="comment">/*                        d = compute_evalue(&amp;en-&gt;EP,list_args);</span>
<a name="l00187"></a>00187 <span class="comment">                                i = d;</span>
<a name="l00188"></a>00188 <span class="comment">                                printf(&quot;(double)%lf = %d\n&quot;, d, i ); */</span>
<a name="l00189"></a>00189       <a class="code" href="source_2arith_2arithmetique_8h.html#a3a9e8def0399e848b9f715238e2378fa">value_set_double</a>(*tmp,<a class="code" href="eval__ehrhart_8c.html#a3f1631cacb65ff7aa29df190b4d30d00">compute_evalue</a>(&amp;en-&gt;<a class="code" href="struct__enumeration.html#aa499b062a10ce16356e9b52d25cae0d9">EP</a>,list_args)+.25);
<a name="l00190"></a>00190       <span class="keywordflow">return</span>(tmp);
<a name="l00191"></a>00191     }
<a name="l00192"></a>00192     <span class="keywordflow">else</span>
<a name="l00193"></a>00193       en=en-&gt;<a class="code" href="struct__enumeration.html#ad2fd42474e015c9abc6aea0e2bea08b8">next</a>;
<a name="l00194"></a>00194   }
<a name="l00195"></a>00195   <a class="code" href="source_2arith_2arithmetique_8h.html#a8cc56567a4a29271559ac0fd5f6c5bfa">value_set_si</a>(*tmp,0);
<a name="l00196"></a>00196   <span class="keywordflow">return</span>(tmp); <span class="comment">/* no compatible domain with the arguments */</span>
<a name="l00197"></a>00197 } <span class="comment">/* compute_poly */</span> 
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
</pre></div></div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:25 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
